//
//  RACompletingTextField.m
//  OpenQuicker
//
//  Created by Quentin Carnicelli on 11/21/04.
//  Copyright 2004 Rogue Amoeba Software, LLC. All rights reserved.
//

#import "RACompletingTextField.h"

@implementation RACompletingTextField

/*
- (void)textDidChange:(NSNotification *)notification
{
	if( mMode == kRACompleteTextAuto )
		[[notification object] complete: nil];
}
*/

- (BOOL)textView:(NSTextView *)textView doCommandBySelector:(SEL)commandSelector
{
	if( (mMode == kRACompleteTextOnTab) &&
		([NSStringFromSelector( commandSelector ) rangeOfString: @"insertTab" options: NSCaseInsensitiveSearch].location != NSNotFound)
	  )
	{
		[textView complete: nil];
		return YES;
	}

	return NO;
}

- (NSArray *)textView:(NSTextView *)textView completions:(NSArray *)words forPartialWordRange:(NSRange)charRange indexOfSelectedItem:(int *)index
{
	if( mMode == kRACompleteTextOff )
		return [NSArray array];

	if( [[self delegate] respondsToSelector: @selector( textView:completions:forPartialWordRange:indexOfSelectedItem: )] )
		return [[self delegate] textView: textView completions: words forPartialWordRange: charRange indexOfSelectedItem: index];

	return words;
}

- (void)setCompletingMode: (RACompletingTextMode)mode
{
	mMode = mode;
}

- (RACompletingTextMode)completingMode
{
	return mMode;
}

@end
